## org.apache.commons.collections.map
Class LazySortedMap

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.map.LazyMap
              org.apache.commons.collections.map.LazySortedMap

All Implemented Interfaces:
  Map, Serializable, SortedMap

public class LazySortedMap
extends LazyMap
implements SortedMap

Decorates another `SortedMap` to create objects in the map on demand.

When the `LazyMap.get(Object)` method is called with a key that does not exist in the map, the factory is used to create the object. The created object will be added to the map using the requested key.

For instance:

     Factory factory = new Factory() {
         public Object create() {
             return new Date();
         }
     }
     SortedMap lazy = Lazy.sortedMap(new HashMap(), factory);
     Object obj = lazy.get("NOW");

After the above code is executed, `obj` will contain a new `Date` instance. Furthermore, that `Date` instance is mapped to the "NOW" key in the map.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.6 $ $Date: 2004/04/09 10:36:01 $
Author:
  Stephen Colebourne, Paul Jack
See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class java.util.Map
`Map.Entry`

Field Summary

Fields inherited from class org.apache.commons.collections.map.LazyMap
`factory`

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` `LazySortedMap(SortedMap map, Factory factory)` Constructor that wraps (not copies).
`protected` `LazySortedMap(SortedMap map, Transformer factory)` Constructor that wraps (not copies).

Method Summary
`Comparator` `comparator()`
`static SortedMap` `decorate(SortedMap map, Factory factory)` Factory method to create a lazily instantiated sorted map.
`static SortedMap` `decorate(SortedMap map, Transformer factory)` Factory method to create a lazily instantiated sorted map.
`Object` `firstKey()`
`protected SortedMap` `getSortedMap()` Gets the map being decorated.
`SortedMap` `headMap(Object toKey)`
`Object` `lastKey()`
`SortedMap` `subMap(Object fromKey, Object toKey)`
`SortedMap` `tailMap(Object fromKey)`

Methods inherited from class org.apache.commons.collections.map.LazyMap
`decorate, decorate, get`

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, entrySet, equals, getMap, hashCode, isEmpty, keySet, put, putAll, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Constructor Detail

### LazySortedMap

    protected LazySortedMap(SortedMap map,
                            Factory factory)

  Constructor that wraps (not copies).

Parameters:
  `map` - the map to decorate, must not be null
  `factory` - the factory to use, must not be null
Throws:
  `IllegalArgumentException` - if map or factory is null

### LazySortedMap

    protected LazySortedMap(SortedMap map,
                            Transformer factory)

  Constructor that wraps (not copies).

Parameters:
  `map` - the map to decorate, must not be null
  `factory` - the factory to use, must not be null
Throws:
  `IllegalArgumentException` - if map or factory is null

Method Detail

### decorate

    public static SortedMap decorate(SortedMap map,
                                     Factory factory)

  Factory method to create a lazily instantiated sorted map.

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `IllegalArgumentException` - if map or factory is null

### decorate

    public static SortedMap decorate(SortedMap map,
                                     Transformer factory)

  Factory method to create a lazily instantiated sorted map.

  Parameters:
    `map` - the map to decorate, must not be null
    `factory` - the factory to use, must not be null
  Throws:
    `IllegalArgumentException` - if map or factory is null

### getSortedMap

    protected SortedMap getSortedMap()

  Gets the map being decorated.

  Returns:
    the decorated map

### firstKey

    public Object firstKey()

  Specified by:
    `firstKey` in interface `SortedMap`

### lastKey

    public Object lastKey()

  Specified by:
    `lastKey` in interface `SortedMap`

### comparator

    public Comparator comparator()

  Specified by:
    `comparator` in interface `SortedMap`

### subMap

    public SortedMap subMap(Object fromKey,
                            Object toKey)

  Specified by:
    `subMap` in interface `SortedMap`

### headMap

    public SortedMap headMap(Object toKey)

  Specified by:
    `headMap` in interface `SortedMap`

### tailMap

    public SortedMap tailMap(Object fromKey)

  Specified by:
    `tailMap` in interface `SortedMap`

Copyright © 2001-2005 Apache Software Foundation. All Rights Reserved.